 /**
  * '원본 문자열' 내에 '찾을 문자열'과 동일한 모든 문자열을 '변경 후 문자열'로 바꾼다.
  * @param inputString 원본 문자열
  * @param targetString 찾을 문자열
  * @param replacement 변경 후 문자열
  * @return
  */
 function replaceAll(inputString, targetString, replacement) {
	 var v_ret = null;
	 var v_regExp = new RegExp(targetString, "g");
	 v_ret = inputString.replace(v_regExp, replacement);

	 return v_ret;
 }

/**
 * 에디터 host 제거
 * @param id
 */
function fn_host_del(id) {
	jQuery('#' + id).val(replaceAll(jQuery('#' + id).val(), 'src="http://' + window.location.host, 'src="'));
}

/**
 * 값 존재 확인
 * @param id : object id
 * @return 값 존재 : true, 값 미존재 : false
 */
function isEmpty(id) {
	var value = jQuery.trim(jQuery('#' + id).val());

	if (value == '') {
		return false;
	}

	return true;
}

/**
 * 값 존재 확인 + 기본 메세지 (obj + " 입력해 주세요.") + focus
 * @param id : object id
 * @param title : title
 * @return 값 존재 : true, 값 미존재 : false
 */
function isEmptyDmsgF(id, title) {
	var msg = title + " 입력해 주세요.";
	var value = jQuery.trim(jQuery('#' + id).val());

	if (value == '') {
		alert(msg);
		jQuery('#' + id).focus();
		return false;
	}

	return true;
}

/**
 * 값 존재 확인 + 사용자 메세지 + focus
 * @param id : object id
 * @param msg : user msg
 * @return 값 존재 : true, 값 미존재 : false
 */
function isEmptyUmsgF(id, msg) {
	var value = jQuery.trim(jQuery('#' + id).val());

	if (value == '') {
		alert(msg);
		jQuery('#' + id).focus();
		return false;
	}

	return true;
}

/**
 * 선택 확인 + 기본 메세지 (obj + " 선택해 주세요.") + focus
 * @param id : input id
 * @param title : title
 * @return 값 존재 : true, 값 미존재 : false
 */
function isSelectDmsgF(id, title) {
	var value = jQuery.trim(jQuery("#" + id + " > option:selected").val());
	var msg = title + " 선택해 주세요.";

	if (value == '') {
		alert(msg);
		jQuery('#' + id).focus();
		return false;
	}

	return true;
}

/**
 * 체크 확인 + 기본 메세지 (obj + " 선택해 주세요.") + focus
 * @param name : input name
 * @param title : title
 * @return 값 존재 : true, 값 미존재 : false
 */
function isRadioDmsg(name, title) {
	var msg = title + " 선택해 주세요.";

	if (jQuery(':radio[name="' + name + '"]:checked').length == 0) {
		alert(msg);
		return false;
	}

	return true;
}

/**
 * 체크박스 전체 선택 및 해제
 * @param srcId : 전체 체크박스 Object id
 * @param targetId : 대상 체크박스 부모 id
 * @return
 */
function allCheck(srcId, targetId) {
	if (jQuery('#' + srcId).attr('checked')) {
		jQuery('#' + targetId + ' input:checkbox').attr("checked", "checked");
	} else {
		jQuery('#' + targetId + ' input:checkbox').attr("checked", "");
	}
}

/**
 *
 * @param id	검색할 field id
 * @param type	검색할 조건 넘버
 * @return
 */
function fieldValid(id, type) {
	var value = jQuery.trim(jQuery('#' + id).val());

	switch (type) {
	/** 메일주소 (aaa@bbb.com) */
		case 1 :
			if (!value.match(/^(\S+)@(\S+)\.(\S+)/g)) {
				return false;
			}
			break;
	/** 숫자만 허용*/
		case 2 :
			if (!value.match(/^[0-9]{0,}$/g)) {
				return false;
			}
			break;
	/** 휴대폰번호 (XXX-XXXX-XXXX) */
		case 3 :
			if (!value.match(/^(010|011|016|017|018|019)-[0-9]{3,4}-[0-9]{3,4}$/g)) {
				return false;
			}
			break;
	/** 휴대폰번호 (XXXXXXXXXXX) */
		case 4 :
			if (!value.match(/^(010|011|016|017|018|019|0505)[0-9]{3,4}[0-9]{4}$/g)) {
				return false;
			}
			break;
	/** 비밀번호 */
		case 5 :
			if (!value.match(/^[a-z0-9]{4,12}/g)) {
				return false;
			}
			break;
	/** 메일주소 (aaa@bbb.com) */
		case 6 :
			var atFirstPoint	= value.indexOf('@');
			var atLastPoint		= value.lastIndexOf('@');
			if (value != "@" && !(atFirstPoint == atLastPoint && value.match(/^(\S+)@(\S+)\.(\S+)/g))) {
				return false;
			}
			break;			
	/** Default */
		default :
			return false;
			break;
	}
	return true;
}


/**
 * 비밀번호 유효성 검사
 * @param pwdId 비밀번호 id
 * @param isAlert : alert 사용유무 (Y:사용, N:미사용)
 * @return isAlert: Y일 경우 성공유무, N일 경우 위배 넘버
 */
function pwdValid(pwdId, isAlert) {
	var value = jQuery.trim(jQuery('#' + pwdId).val());

	var chk_num = value.search(/[0-9]/g);
	var chk_eng = value.search(/[a-z]/ig);


	if (!/^[a-zA-Z0-9]{4,12}$/.test(value)) {
		if (isAlert == 'Y') {
			alert("비밀번호는 숫자와 영문자 조합으로 4~12자리를 사용해야 합니다.");
			return false;
		} else {
			return '1';
		}
	} else if (chk_num < 0 || chk_eng < 0) {
		if (isAlert == 'Y') {
			alert("비밀번호는 숫자와 영문자를 혼용하여야 합니다.");
			return false;
		} else {
			return '2';
		}
	} else if (/(\w)\1\1\1/.test(value)) {
		if (isAlert == 'Y') {
			alert("비밀번호에 같은 문자를 4번 이상 사용하실 수 없습니다.");
			return false;
		} else {
			return '3';
		}
	}

	return true;
}

/**
 * 이미지 파일 여부 확인
 * @param id
 * @param msg
 * @returns {Boolean}
 */
function isImgExt(id, msg) {
	var value = jQuery.trim(jQuery('#' + id).val());
	if (value != "") {
		var imgExt = value.toUpperCase();
		imgExt = imgExt.substring(imgExt.lastIndexOf(".") + 1);

		if (imgExt != 'GIF' && imgExt != 'JPG' && imgExt != 'JPEG' && imgExt != 'BMP' && imgExt != 'PNG') {
			alert(msg + ' 이미지 파일만 첨부 가능 합니다.');
			jQuery('#' + id).focus();
			return false;
		}
	}

	return true;
}

/**
 * byte 초과 확인
 * @param id
 * @param nByte
 * @return
 */
function jsByteSubstr(id, nByte) {
	var result = true;
	var objVal = jQuery('#' + id).val();

	with (Math) {
		var nLength = objVal.length;
		var nCnt = 0;
		var nHan, nTemp;

		// 한글 문자수 계산(버림)
		nHan = nByte / 2;
		nTemp = round(nHan);

		if (nHan != nTemp) {
			nHan = nTemp - 1;
		}

		for (var i = 0; i < nLength; i++) {
			sTemp = escape(objVal.substring(i, i + 1));

			if (sTemp.substring(1, 2) == "u") {
				nCnt += 2;
			} else {
				nCnt += 1;
			}

			if (nCnt > nByte) {
				return false;
			}
		}
	}

	return result;
}

/**
 *
 * @param e		 event
 * @param isAlert : alert 사용유무 (Y:사용, N:미사용)
 * @return isAlert: Y일 경우 성공유무, N일 경우 (1 : capslock on, 2 : capslock off)
 */
function checkCapsLock(e, isAlert) {
	var myKeyCode = 0;
	var myShiftKey = false;

	// Internet Explorer 4+
	if (document.all) {
		myKeyCode = e.keyCode;
		myShiftKey = e.shiftKey;
		// Netscape 4
	} else if (document.layers) {
		myKeyCode = e.which;
		myShiftKey = ( myKeyCode == 16 )? true: false;
		// Netscape 6
	} else if (document.getElementById) {
		myKeyCode = e.which;
		myShiftKey = ( myKeyCode == 16 )? true: false;
	}

	// Upper case letters are seen without depressing the Shift key, therefore Caps Lock is on
	if (( myKeyCode >= 65 && myKeyCode <= 90 ) && !myShiftKey) {
		if (isAlert == 'Y') {
			alert('키보드에 CapsLock이 켜져 있습니다.');
			return false;
		} else {
			return '1';
		}
		// Lower case letters are seen while depressing the Shift key, therefore Caps Lock is on
	} else if (( myKeyCode >= 97 && myKeyCode <= 122 ) && myShiftKey) {
		if (isAlert == 'Y') {
			alert('키보드에 CapsLock이 켜져 있습니다.');
			return false;
		} else {
			return '1';
		}
	} else {
		if (isAlert == 'Y') {
			return true;
		} else {
			return '2';
		}
	}
}

/**
 * 팝업 (center, resizable:no, scrollbars:no)
 * @param url		open 할 URL
 * @param name		popup 이름
 * @param width		가로
 * @param height	세로
 * @return
 */
function popupCenter(url, name, width, height) {
	var LeftPosition = (screen.width)? (screen.width - width) / 2: 0;
	var TopPosition = (screen.height)? (screen.height - height) / 2: 0;
	var settings = 'height=' + height + ',width=' + width + ',top=' + TopPosition + ',left=' + LeftPosition + ',status=no,toolbar=no,menubar=no,location=no,fullscreen=no,resizable=no,scrollbars=no';
	return win = window.open(url, name, settings);
}

/**
 * 팝업 (center, resizable:yes, scrollbars:no)
 * @param url		open 할 URL
 * @param name		popup 이름
 * @param width		가로
 * @param height	세로
 * @return
 */
function popupCenterResize(url, name, width, height) {
	var LeftPosition = (screen.width)? (screen.width - width) / 2: 0;
	var TopPosition = (screen.height)? (screen.height - height) / 2: 0;
	var settings = 'height=' + height + ',width=' + width + ',top=' + TopPosition + ',left=' + LeftPosition + ',status=no,toolbar=no,menubar=no,location=no,fullscreen=no,resizable=yes,scrollbars=no';
	return win = window.open(url, name, settings);
}

/**
 * 팝업 (center, resizable:no, scrollbars:yes)
 * @param url		open 할 URL
 * @param name		popup 이름
 * @param width		가로
 * @param height	세로
 * @return
 */
function popupCenterScroll(url, name, width, height) {
	var LeftPosition = (screen.width)? (screen.width - width) / 2: 0;
	var TopPosition = (screen.height)? (screen.height - height) / 2: 0;
	var settings = 'height=' + height + ',width=' + width + ',top=' + TopPosition + ',left=' + LeftPosition + ',status=no,toolbar=no,menubar=no,location=no,fullscreen=no,resizable=no,scrollbars=yes';
	return win = window.open(url, name, settings);
}

/**
 * 팝업 (왼쪽,위 open, 옵션 직접 지정)
 * @param url		open 할 URL
 * @param name		popup 이름
 * @param width		가로
 * @param height	세로
 * @param scroll	스크롤 (yes or no)
 * @param resize	리사이즈 (yes or no)
 * @return
 */
function popupOpen(url, name, width, height, scroll, resize) {
	return win = window.open(url, name,
	                         "width=" + width + ",height=" + height + ",scrollbars=" + scroll + ",resizable=" + resize + ",toolbar=no,left=0,top=0");
}

/**
 * 우편번호 팝업을 호출 한다.
 */
function fn_zipcode_pop() {
	popupCenter("/common/zipcode/list.sky", "zipcode", 600, 400);
}

/**
 * 엑셀 다운로드
 * @param action action url
 * @param formId form id
 */
function fn_excel(action, formId) {
	jQuery("#" + formId).attr('action', action);
	jQuery("#" + formId).submit();
}

/**
 * 정렬 순서 변경
 * @param formId form id
 * @param action form action
 * @param order_type 정렬 타입
 * @param order_way 정렬 방법
 */
function fn_order(formId, action, order_type, order_way) {
	jQuery("#order_type").val(order_type);
	jQuery("#order_way").val(order_way);
	jQuery("#" + formId).attr('action', action);
	jQuery("#" + formId).submit();
}

/**
 * 코드 셀렉트 목록
 * @param objId		change select id
 * @param targetId  change target id
 * @param msg		option default msg
 */
function fn_code_change(objId, targetId, msg) {
	var objVal = jQuery("#" + objId + " > option:selected").val();
	var optionStr = "";
	jQuery.post('/unity/code/list_option.sky', 'pcode=' + objVal, function (data) {
		if (msg != "") {
			optionStr = "<option value=''>" + msg + "</option>";
		}
		optionStr += data.subCodeList;
		jQuery("#" + targetId).html(optionStr);
	}, "json");
}


/**
 * 코드 셀렉트 목록
 * 2012.2.15 김솔비 추가
 * @param objId		change select id
 * @param targetId  change target id
 * @param msg		option default msg
 */
function fn_code_change_style(objId, targetId, msg) {
	var objVal = jQuery("#" + objId + " > option:selected").val();
	var optionStr = "";
	jQuery.post('/unity/code/list_option.sky', 'pcode=' + objVal, function (data) {
		if (msg != "") {
			optionStr = "<option value=''>" + msg + "</option>";
		}

		$("#" + targetId + '_input').remove();
		$("#" + targetId + '_container').remove();
		$("#" + targetId).empty();

		optionStr += data.subCodeList;
		jQuery("#" + targetId).html(optionStr);

		jQuery("#" + targetId).selectbox({
			                                 //inputClass:'select_basic',
			                                 //containerClass:'select_basic_wrapper',
			                                 //hoverClass:'current',
			                                 //currentClass:'selected',
			                                 //maxHeight:120,
			                                 //debug:false
		                                 });
	}, "json");
}

function fn_open_bg() {
	jQuery(".grayBg").height(jQuery(document).height()).show();
}

function fn_close_bg() {
	jQuery(".grayBg").hide();
	jQuery('#layerId').hide();
}

function fn_close_bg_id(idName) {
	jQuery(".grayBg").hide();
	jQuery('#' + idName).hide();
}

/**
 * 로그인 페이지로 이동
 * 2012.2.16 김솔비
 * @param return_url
 */
function fn_required_login(return_url) {
	if (confirm("로그인이 필요한 서비스입니다.\n로그인 하시겠습니까?")) {
		parent.location.href = '/etc/login.sky?rurl=' + encodeURIComponent(return_url);
	}
}

/**
 * 스크롤 값
 * @returns ''
 */
function scrollTopPx(scrollTop) {
	var id = "#" + $("div.popHeader").parent("div").attr("id");
	var top = $(window).height() / 2 + scrollTop - ($(id).height() / 2);
	if($(id).height() >= $(window).height()) {
		top += ($(id).height() - $(window).height()) / 2;
	}
	$(id).css("top", top);
}

/**
 * 통신사, 휴대폰 종류에 대한 제품 목록
 */
function fn_agency_change() {
	var strtelecomcode = jQuery(':radio[name="agency_code"]:checked').val();
	var phonetype = jQuery(':radio[name="phonetype"]:checked').val();
	var selectedModelnm = jQuery('#pre_search_modelnm').val();

	if (strtelecomcode == undefined) {
		strtelecomcode = "";
	}
	if (phonetype == undefined) {
		phonetype = "";
	}

	// calback 함수를 인자로 전달하였을 경우 이를 새로운 select tag에 적용한다.
	var callback = (arguments.length > 2)? arguments[2]: "";

	var action = "/cmm/mdl/list_option.sky";
	var param = "strtelecomcode=" + strtelecomcode + "&phonetype=" + phonetype + "&search_modelnm=" + selectedModelnm+ "&CURITELYN=N";

	jQuery.post(action, param, function (data) {
		var result = "<option value=''>닉네임/모델명 선택</option>";

		if (data.RESULT_CODE == "SUCCESS") {
			result += jQuery.trim(data.MODELLIST);
		}
		addSelect('mdl_nm', result, callback);
	}, "json");
}

function fn_agency_change_sel() {
	var strtelecomcode = jQuery(':radio[name="agency_code"]:checked').val();
	var phonetype = jQuery(':radio[name="phonetype"]:checked').val();
	var selectedModelnm = jQuery('#pre_search_modelnm').val();
	
	if (strtelecomcode == undefined) {
		strtelecomcode = "";
	}
	if (phonetype == undefined) {
		phonetype = "";
	}

	// calback 함수를 인자로 전달하였을 경우 이를 새로운 select tag에 적용한다.
	var callback = (arguments.length > 2)? arguments[2]: "";

	var action = "/cmm/mdl/list_option.sky";
	var param = "strtelecomcode=" + strtelecomcode + "&phonetype=" + phonetype + "&search_modelnm=" + selectedModelnm+ "&CURITELYN=Y";

	jQuery.post(action, param, function (data) {
		var result = "<option value=''>닉네임/모델명 선택</option>";

		if (data.RESULT_CODE == "SUCCESS") {
			result += jQuery.trim(data.MODELLIST);
		}
		addSelect('mdl_nm', result, callback);
	}, "json");
}

/**
 * 이통사 코드를 이용하여 이름을 반환한다.
 *
 * @param agencyCode 이통사 코드
 */
function agencyName(agencyCode) {
	return (agencyCode == "11001")? "SKT": (agencyCode == "11002")? "KT": (agencyCode == "11003")? "LGT": "CJ Hello";
}

/**
 * 트위터 / 페이스북 공유하기
 */
function sns_share(gubun,pcode,pseq) {
	var url = location.href;
	url = url.replace('#', '');
	if(gubun == "twitter"){
		jQuery.ajax({
			url : "/social/twitter/shUrl.sky",
			dataType: "text",
			data :"url="+url+"&pcode="+pcode+"&pseq="+pseq+"&gubun="+gubun ,
			success: function(data){
				window.open("https://twitter.com/share?url="+data, '', 'width=600, height=350, scrollbars=no');
			},
			error: function(data){
				alert("error : " + data.responseText);
			}
		});
	} else if(gubun == "facebook") {
		jQuery.ajax({
			url : "/social/twitter/shUrl.sky",
			dataType: "text",
			data :"url="+url+"&pcode="+pcode+"&pseq="+pseq+"&gubun="+gubun ,
			success: function(data){
				window.open("http://www.facebook.com/sharer.php?u="+data, '', 'width=900, height=600, scrollbars=no');
			},
			error: function(data){
				alert("error : " + data.responseText);
			}
		});
	 }
}

// 우측메뉴 배너 자동 롤링
function fn_right_banner_rolling() {
	jQuery("div#rightBanner p[name=temp]").each(function(i) {
	    jQuery(this).css("display", "none");
	});
	jQuery("div#rightBanner > p#rightBtn > a").each(function(i) {
	    jQuery(this).removeClass("current");
	});

	jQuery("#rightBannerP" + rightCurNum).css("display", "block");
	jQuery("#rightBannerBtn" + rightCurNum).addClass("current");

	rightCurNum = rightCurNum + 1;
	if(rightCurNum == rightMaxNum) {
		rightCurNum = 0;
	}
}

// 우측메뉴 배너 버튼 클릭 시
function fn_right_banner(idx) {
	jQuery("div#rightBanner p[name=temp]").each(function(i) {
	    jQuery(this).css("display", "none");
	});
	jQuery("div#rightBanner > p#rightBtn > a").each(function(i) {
	    jQuery(this).removeClass("current");
	});

	jQuery("#rightBannerP" + idx).css("display", "block");
	jQuery("#rightBannerBtn" + idx).addClass("current");

	rightCurNum = idx + 1;
	if(rightCurNum == rightMaxNum) {
		rightCurNum = 0;
	}
}

 /**
  * Cancel enterKey event
  * @param event
  */
function cancelEnterKey(event) {
	if (window.event && event.keyCode == 13) {
		return false;
	} else return event.which != 13;
}

/**
 * 접속 기기 확인
 * @param viewType
 * @returns {String}
 */
function accessCheck(viewType) {
	var isWeb = true;
	var isTablet = false;
	var type = "PC";

	if(viewType != "M"){
		var mobileKeyWords = new Array('iPhone', 'iPod', 'BlackBerry', 'Android', 'Windows CE', 'LG', 'MOT', 'SAMSUNG', 'SonyEricsson');
		var length = mobileKeyWords.length;

		for (var i = 0; i < length; i++) {
			if (navigator.userAgent.indexOf(mobileKeyWords[i]) != -1){
				isWeb = false;
		        break;
		    }
		}

		// 모바일 접속 일 경우 태블릿 PC 여부 확인
		if(!isWeb) {
			var tabletKeyWords = new Array('SHW-M380', 'LG-LU8300', 'iPad');
			for (var j = 0; j < length; j++) {
    		    if (navigator.userAgent.indexOf(tabletKeyWords[j]) != -1){
    		    	isTablet = true;
    		        break;
    		    }
    		}
		}

		if(isTablet) {
			type = "TABLET";
		} else if(!isWeb) {
			type = "MOBILE";
		}

		return type;
	}
}

//추천하기
function fn_recomm(rurl, token, pcode, pseq, gubun) {
	jQuery.post('/customer/cmm/recomm.sky',
        {com_sky_request_token:token, pcode:pcode, pseq:pseq, gubun:gubun},
        function (data) {
            if (data.msg == "LOGIN") {
	            fn_required_login(rurl);
            } else if (data.msg == "SUCCESS") {
	            alert("추천되었습니다.");
            } else if (data.msg == "EXISTS") {
	            alert("이미 추천된 게시글입니다.");
            } else {
	            alert("추천 중 오류가 발생하였습니다.");
            }
        }, "json");
}

// 금칙어
function fn_prohibit(prohibitList, id) {
	var content = jQuery('#' + id).val();
	var result = true;
	for(var i = 0; i < prohibitList.length; i++) {
		if(content.indexOf(prohibitList[i].PROHIBIT_WORD) != -1) {
			//alert("'" + prohibitList[i].PROHIBIT_WORD + "' 은[는] 입력할 수 없는 단어 입니다.");
			alert("제목이나 내용에 금칙어가 포함되어 있습니다.");
			result = false;
			break;
		}
	}
	return result;
}

//ifrme 높이조절
function resizeFrame(frm) {
    //frm.style.height = "auto";
    contentHeight = frm.contentWindow.document.body.scrollHeight;
    frm.style.height = contentHeight + ((contentHeight < 110)? 30: 4) + "px";
}
