
$(function() {
    if($.browser.name == 'msie') {
        $('body').addClass($.browser.className);
    } else {
        $('body').addClass($.browser.name);
    }

    $('.ui_select').selectbox({ 				// 셀렉터 class 지정
		inputClass:'select_basic', 				// input 클래스 지정
		containerClass:'select_basic_wrapper', 	// div 클래스 지정
		hoverClass:'current', 					// 오버 클래스 지정
		currentClass:'selected', 				// 선택 클래스 지정
		maxHeight:120, 							// 최대 높이값(보다크면 스크롤 생성)
		debug:false 							// debug mode on/off
	});
});

jQuery.fn.extend({
	selectbox: function(options) {
		return this.each(function() {
			new jQuery.SelectBox(this, options);
		});
	}
});


jQuery.SelectBox = function(selectobj, options) {
	var opt = options || {};
	opt.inputClass = opt.inputClass || "select_basic";
	opt.containerClass = opt.containerClass || "select_basic_wrapper";
	opt.hoverClass = opt.hoverClass || "current";
	opt.currentClass = opt.selectedClass || "selected";
	opt.maxHeight = opt.maxHeight || 120;
	opt.onChangeCallbak = opt.onChangeCallback || false;
	opt.onChangeParams = opt.onChangeParams || false;
	opt.debug = opt.debug || false;

	var elm_id = selectobj.id;
	if (jQuery("#" + elm_id + "_container").attr("id") != undefined) {
		return;
	}

	var active = 0;
	var inFocus = false;
	var hasfocus = 0;
	var containerFocus = 0;
	var $select = $(selectobj);							// select box
	var $container = setupContainer(opt); 				// div create : select box id + _container
	var $input = setupInput(opt);						// text create : select box id + _input
	$select.hide().before($input).before($container);	// select box hide && div, text append

	init();												// container setup

	$container.mouseover(function(event) {
		containerFocus = 1;
	});

	$container.mouseout(function(event) {
		containerFocus = 0;
	});

	$input
	.click(function(){
		$container.parent().css('z-index','100');
		if (!inFocus) {
			$container.toggle();
		}
	})
	.focus(function(){
		$container.parent().css('z-index','100');
		if ($container.not(':visible')) {
	       inFocus = true;
	       $container.show();
		}
	})
	.keydown(function(event) {
		switch(event.keyCode) {
			case 38: // up
				event.preventDefault();
				moveSelect(-1);
				break;
			case 40: // down
				event.preventDefault();
				moveSelect(1);
				break;
			case 13: // return
				event.preventDefault(); // seems not working in mac !
				$('li.'+opt.hoverClass).trigger('click');
				break;
			case 27: //escape
			  hideMe();
			  break;
		}
	})
	.blur(function() {
		if ($container.is(':visible') && hasfocus > 0 ) {
			if(opt.debug) console.log('container visible and has focus')
		} else {
			if($.browser.msie || $.browser.safari){
				if(containerFocus == 1) {
					$input.focus();
				} else {
					hideMe();
				}
				/*
				if(document.activeElement.id.indexOf('_container') == -1){
					hideMe();
				} else {
					$input.focus();
				}
				*/
			} else {
				hideMe();
			}
		}
	});

	function hideMe() {
		hasfocus = 0;
		$container.hide();
		$container.parent().css('z-index','0');
	}

	/**
	 *
	 */
	function init() {
		$container.append(getSelectOptions($input.attr('id')))
		setHeight();
		setPosition();
		$container.hide();
	}

	/**
	 * div container create
	 */
	function setupContainer(options) {
		var container = document.createElement("div");
		$container = $(container);
		$container.attr('id', elm_id+'_container');
		$container.addClass(options.containerClass);
		$container.width($select.width());
		return $container;
	}

	/**
	 * selected input text create
	 */
	function setupInput(options) {
		var input = document.createElement("input");
		var $input = $(input);
		$input.attr("id", elm_id+"_input");
		$input.attr("type", "text");
		$input.addClass(options.inputClass);
		$input.attr("autocomplete", "off");
		$input.attr("readonly", "readonly");
		$input.width($select.width());
		return $input;
	}

	function moveSelect(step) {
		var lis = $("li", $container);
		if (!lis || lis.length == 0) return false;
		active += step;
		if (active < 0) {
			active = lis.size();
		} else if (active > lis.size()) {
			active = 0;
		}
		scroll(lis, active);
		lis.removeClass(opt.hoverClass);

		$(lis[active]).addClass(opt.hoverClass);
	}

	function scroll(list, active) {
		var el = $(list[active]).get(0);
		var list = $container.get(0);

		if (el.offsetTop + el.offsetHeight > list.scrollTop + list.clientHeight) {
			list.scrollTop = el.offsetTop + el.offsetHeight - list.clientHeight;
		} else if(el.offsetTop < list.scrollTop) {
			list.scrollTop = el.offsetTop;
		}
	}

	function setCurrent() {
		var li = $("li."+opt.currentClass, $container).get(0);
		var ar = (''+li.id).split('_');
		var el = ar[ar.length-1];
		$select.get(0).selectedIndex = $('li', $container).index(li);
		$input.val($(li).text());
		if (opt.onChangeCallback) opt.onChangeCallback($select);
		return true;
	}

	// select value
	function getCurrentSelected() {
		return $select.val();
	}

	// input value
	function getCurrentValue() {
		return $input.val();
	}

	// container ul create && li event
	function getSelectOptions(parentid) {
		var select_options = new Array();
		var ul = document.createElement('ul');

		// container option create
		$select.children('option').each(function() {
			var li = document.createElement('li');
			li.setAttribute('id', parentid + '_' + $(this).val());
			li.innerHTML = $(this).text();
			if ($(this).is(':selected')) {
				$input.val($(this).text());
				$(li).addClass(opt.currentClass);
			}
			ul.appendChild(li);

			// option event
			$(li)
			.mouseover(function(event) {
				hasfocus = 1;
				jQuery(event.target, $container).addClass(opt.hoverClass);
			})
			.mouseout(function(event) {
				hasfocus = -1;
				jQuery(event.target, $container).removeClass(opt.hoverClass);
			})
			.click(function(event) {
				var fl = $('li.'+opt.hoverClass, $container).get(0);
				$('li.' + opt.currentClass).removeClass(opt.currentClass);
				$(this).addClass(opt.currentClass);
				setCurrent();
				$select.get(0).blur();
				hideMe();
			});
		});
		return ul;
	}

	function setPosition() {
		var document_height = $(document).height();
		var input_offset = $input.offset();
		var select_height = input_offset.top + $container.height();
		if(document_height >= select_height) {
			$container.css({'top':
				function() {
					return ($input.outerHeight() - 1) + 'px';
				}
			})
		} else {
			$container.css({'top':
				function() {
					return '-' + $container.height() + 'px';
				}
			})
		}
	}

	function setHeight() {
		if($container.height() > options.maxHeight) {
			$container.height(options.maxHeight);
		}
	}
};

/* select axax */
function addSelect(selectId, selectData, callback) {
	var selectId = selectId;
	var selectData = selectData;
	$("#" + selectId + "_input").remove();
	$("#" + selectId + "_container").remove();
	$("#" + selectId).empty();
	$("#" + selectId).html(selectData);
	$("#" + selectId).selectbox({
		onChangeCallback : callback,
		inputClass:'select_basic',
		containerClass:'select_basic_wrapper',
		hoverClass:'current',
		currentClass:'selected',
		maxHeight:120,
		debug:false
	});
}
function addSelect2(selectId, selectData, callback, selectContent) {
	var selectId = selectId;
	var selectData = selectData;
	$(selectId + '_input').remove();
	$(selectId + '_container').remove();
	$(selectId).empty();
	$(selectId).append(selectData);
	$(selectId + " > option[value='" + selectContent + "']").attr("selected","true");
	$(selectId).selectbox({
		onChangeCallback : callback,
		inputClass:'select_basic',
		containerClass:'select_basic_wrapper',
		hoverClass:'current',
		currentClass:'selected',
		maxHeight:120,
		debug:false
	});
}
